/*
 *	STRINGS.C	(C adaptation of STRINGS.MAR)
 */

#include <string.h>
#include <ctype.h>
/*
 * bcopy()
 *
 * copies length of source to destination
 */
void bcopy (src, dest, length)
char *src, *dest;
unsigned long int length;
{
  memcpy(dest, src, length);
}

/*
 * bcmp()
 *
 * compare src againist destination for length bytes.
 *
 * return -1 if src < dest, 0 if src = dest, 1 if src > dest
 */
int bcmp(src, dest, length)
char *src, *dest;
unsigned long int length;
{
   return((int)memcmp(src, dest, length));
}

/*
 * bzero()
 *
 * zero out source for length bytes
 */
void bzero(src, length)
char *src;
unsigned long int length;
{
   memset(src, 0, length);
}

/*
 * ffs()
 *
 * finds the first bit set in the argument and returns the index
 * of that bit (starting at 1).
 */
int ffs(mask)
unsigned long int mask;
{
   register int i;

   for (i = 0; i < sizeof(mask); i++)
	if (mask & (1 << i)) return (i+1);

   return(-1);
}

/*
 * index()
 *
 * returns a pointer to the first occurrence of a character within
 * a string
 */

char *index(string, c)
char *string, c;
{
   return(strchr(string,c));
}

/*
 * rindex
 *
 * returns a pointer to the last occurrence of a character within
 * a string
 */

char *rindex(string, c)
char *string, c;
{
   return (strrchr(string,c));
}

/* $Id: strcasecmp.c,v 3.6 1993/10/21 11:11:46 bert Exp $
 *
 * XPilot, a multiplayer gravity war game.  Copyright (C) 1991-93 by
 *
 *      Bjrn Stabell        (bjoerns@staff.cs.uit.no)
 *      Ken Ronny Schouten   (kenrsc@stud.cs.uit.no)
 *      Bert Gsbers         (bert@mc.bio.uva.nl)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


/*
 * By Ian Malcom Brown.
 * Changes by BG: prototypes with const,
 * moved the ++ expressions out of the macro.
 */
int strcasecmp(const char *str1, const char *str2)
{
    int	c1, c2;


    do {
	c1 = *str1++;
	c2 = *str2++;
	c1 = tolower(c1);
	c2 = tolower(c2);
    } while (c1 != 0 && c2 != 0 && c1 == c2);

    return (c1 - c2);
}

/*
 * By Bert Gijsbers, derived from Ian Malcom Brown's strcasecmp().
 */
int strncasecmp(const char *str1, const char *str2, size_t n)
{
    int	c1, c2;

    do {
	if (n-- <= 0) {
	    return 0;
	}
	c1 = *str1++;
	c2 = *str2++;
	c1 = tolower(c1);
	c2 = tolower(c2);
    } while (c1 != 0 && c2 != 0 && c1 == c2);

    return (c1 - c2);
}
